
#ifndef CNOID_GUIBASE_OSG_NORMAL_VISUALIZER_H_INCLUDED
#define CNOID_GUIBASE_OSG_NORMAL_VISUALIZER_H_INCLUDED

#include <osg/Geode>
#include "exportdecl.h"

namespace cnoid {

    class CNOID_EXPORT OSGNormalVisualizer : public osg::Geode 
    {
      public:
        enum Mode { SURFACE, VERTEX };
        OSGNormalVisualizer(osg::Node *node, float scale = 0.01, Mode mode = SURFACE);
      protected:
        ~OSGNormalVisualizer() {}
    };
    

    class CNOID_EXPORT OSGSurfaceNormalVisualizer : public OSGNormalVisualizer
    {
      public:
        OSGSurfaceNormalVisualizer(Node *node, float scale = 0.01)
            : OSGNormalVisualizer(node, scale, SURFACE) { }
      protected:
        ~OSGSurfaceNormalVisualizer() { }
    };
  
  
    class CNOID_EXPORT OSGVertexNormalVisualizer : public OSGNormalVisualizer
    {
      public:
        OSGVertexNormalVisualizer(Node* node, float scale = 0.01)
            : OSGNormalVisualizer(node, scale, VERTEX) { }
      protected:
        ~OSGVertexNormalVisualizer() { }
    };
  
}

#endif
